<?php require_once(ROOT . "/views/" . LANG . "/layouts/_header_c.php"); ?>

<div class="page-content-wrapper ">
  <div class="container">
    <div class="row">
      <div class="col-lg-9 partner_cl">
        <div class="panel panel-primary">
          <div class="panel-body">
            <p class="raceinfotext">Калькулятор дохода служит для расчета Вашей прибыли от танков в ангаре. <b>Калькулятор не учитывает возможные бонусы, а так же реферальные вознаграждения.</b> Калькулятор считает только чистую прибыль за час, сутки, месяц и год согласно скорости заработка каждого из танков Вашего Ангара.</p>
            <hr>
            <div class="ideas_coment text-center">Введите необходимое количество Танков для расчета:</div>
            <hr class="m-b-10">
            <div class="row">
              
            <?php foreach ($plans as $plan) : ?>

              <div class="col-md-4">
                <div class="form-group">
                  <label class="control-label">Танк <?=$plan['id']; ?> ур.</label>
                  <input id="car<?=$plan['id']; ?>" class="vertical-spin" type="text" value="0" name="vertical-spin">
                </div>
              </div>

            <?php endforeach; ?>

            </div>
            <div class="text-center m-t-10">
              <button type="button" class="btn waves-effect btn-primary btn-block calc_btn" style="width:300px;" onclick="calculate();"><i class="fa fa-calculator"></i> Рассчитать доход</button>
            </div>
            <div class="row">
              <div class="col-md-4 col-md-offset-4 p-t-10">
                <div class="calc_resultline">Доход за 1 час: <div id="dhd1">0 руб.</div></div>
                <div class="calc_resultline">Доход за 24 часа: <div id="dhd2">0 руб.</div></div>
                <div class="calc_resultline">Доход за 30 дней: <div id="dhd3">0 руб.</div></div>
                <div class="calc_resultline">Доход за 365 дней: <div id="dhd4">0 руб.</div></div>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div><!-- end row -->
  </div><!-- container -->
</div> <!-- Page content Wrapper -->

<script>
var cars=[];

<?php foreach ($plans as $plan) : ?>

  cars[<?=$plan['id']; ?>]=<?=$plan['perc']; ?>;

<?php endforeach; ?>

function number_format( number, decimals, dec_point, thousands_sep ) {

  var i, j, kw, kd, km;

  if( isNaN(decimals = Math.abs(decimals)) ){
    decimals = 2;
  }
  if( dec_point == undefined ){
    dec_point = ",";
  }
  if( thousands_sep == undefined ){
    thousands_sep = ".";
  }

  i = parseInt(number = (+number || 0).toFixed(decimals)) + "";

  if( (j = i.length) > 3 ){
    j = j % 3;
  } else{
    j = 0;
  }

  km = (j ? i.substr(0, j) + thousands_sep : "");
  kw = i.substr(j).replace(/(\d{3})(?=\d)/g, "$1" + thousands_sep);
  kd = (decimals ? dec_point + Math.abs(number - i).toFixed(decimals).replace(/-/, 0).slice(2) : "");


  return km + kw + kd;
}


function calculate() {
  var h1=0;
  var h24=0;
  var d30=0;
  var d365=0;
  for(var i=1;i<=<?=count($plans); ?>;i++) {
    h1+=cars[i]*parseInt($("#car"+i).val());
    h24+=cars[i]*parseInt($("#car"+i).val())*24;
    d30+=cars[i]*parseInt($("#car"+i).val())*24*30;
    d365+=cars[i]*parseInt($("#car"+i).val())*24*365;
  }
  $("#dhd1").html(number_format(h1, 4, '.', ' ')+" руб.");
  $("#dhd2").html(number_format(h24, 3, '.', ' ')+" руб.");
  $("#dhd3").html(number_format(d30, 2, '.', ' ')+" руб.");
  $("#dhd4").html(number_format(d365, 0, '.', ' ')+" руб.");
}
</script>

<?php require_once(ROOT . "/views/" . LANG . "/layouts/_footer_c.php"); ?>
